This is the mail archive of the crossgcc@sourceware.org mailing list for the crossgcc project.

See the CrossGCC FAQ for lots more information.


Index Nav: [Date Index] [Subject Index] [Author Index] [Thread Index]
Message Nav: [Date Prev] [Date Next] [Thread Prev] [Thread Next]
Other format: [Raw text]

[PATCH] Add a 'auto' value for the number of parallel jobs


# HG changeset patch
# User Michael Hope <michael.hope@linaro.org>
# Date 1317253242 -46800
# Node ID 69e6e581338dc4558d87fdcde9d9cbf8466893c9
# Parent  780d29fbc4c574ded2248f55e77dd7cb1540aea4
Add a 'auto' value for the number of parallel jobs.

When CT_PARALLEL_JOBS is -1, set the number of parallel jobs to the
number of online CPUs + 1.  Update documentation to match.

I find this useful when building in the cloud.  You can use the same
.config file and have the build adapt to the number of processors
available.  Limited testing shows that NCPUS+1 is faster than NCPUS+0
or NCPUS+2.

Signed-off-by: Michael Hope <michael.hope@linaro.org>

diff -r 780d29fbc4c5 -r 69e6e581338d config/global/build-behave.in
--- a/config/global/build-behave.in	Thu Sep 29 12:27:54 2011 +1300
+++ b/config/global/build-behave.in	Thu Sep 29 12:40:42 2011 +1300
@@ -16,6 +16,8 @@
       
       Enter 1 (or 0) to have only one job at a time.
 
+      Enter -1 to set automatically based on how many processors the host has.
+
 config LOAD
     int
     prompt "Maximum allowed load" if ! BACKEND
diff -r 780d29fbc4c5 -r 69e6e581338d scripts/crosstool-NG.sh.in
--- a/scripts/crosstool-NG.sh.in	Thu Sep 29 12:27:54 2011 +1300
+++ b/scripts/crosstool-NG.sh.in	Thu Sep 29 12:40:42 2011 +1300
@@ -488,7 +488,11 @@
 
     # And help make go faster
     JOBSFLAGS=
-    [ ${CT_PARALLEL_JOBS} -ne 0 ] && JOBSFLAGS="${JOBSFLAGS} -j${CT_PARALLEL_JOBS}"
+    # Use the number of processors+1 when automatically setting the number of
+    # parallel jobs.  Fall back to 1 if the host doesn't use GLIBC.
+    AUTO_JOBS=$((`getconf _NPROCESSORS_ONLN 2> /dev/null || echo 0` + 1))
+    [ ${CT_PARALLEL_JOBS} -eq -1 ] && JOBSFLAGS="${JOBSFLAGS} -j${AUTO_JOBS}"
+    [ ${CT_PARALLEL_JOBS} -gt 0 ] && JOBSFLAGS="${JOBSFLAGS} -j${CT_PARALLEL_JOBS}"
     [ ${CT_LOAD} -ne 0 ] && JOBSFLAGS="${JOBSFLAGS} -l${CT_LOAD}"
 
     # We need to save the real .config with kconfig's value,

--
For unsubscribe information see http://sourceware.org/lists.html#faq


Index Nav: [Date Index] [Subject Index] [Author Index] [Thread Index]
Message Nav: [Date Prev] [Date Next] [Thread Prev] [Thread Next]